package CorrectASSPcfg;
use strict qw(vars subs);

# V2 build 13177 (at least !)
#
# If this Package is available, it will be loaded by assp and the sub set will be called, 
# after the configuration is parsed.
# You are free to modify any config parameter here - see the examples in 'sub set'.

# *********************************************************************************************************************************************
# hidden config variables that could be changed using this module CorrectASSPcfg.pm
# or that could be changed using a commandline switch like --enableCrashAnalyzer:=1
# the values shown are the default values
# *********************************************************************************************************************************************
# $main::enableCrashAnalyzer = 0;            # (0/1) enable the automatic crash analyzer (CA)
# $main::CrashAnalyzerTopCount = 10;         # (number > 0) number of records used for the CA top count
# $main::CrashAnalyzerWouldBlock = 1;        # (0/1) block the mail if CA detects that the mail would crash ASSP
# $main::IPv6TestPort = '51965';             # (port number) the port number that is used at startup to bind IPv6 to - to check if IPv6 is available
# $main::AnalyzeLogRegex = 0;                # (0/1) enables enhanced regex analyzing (in console mode only)
# $main::HMMSequenceLength = 4;              # (number > 0) count of words used for a sequence
# $main::HMMDBWords = 600;                   # (number > 0) number of words used per mail in rebuildspamdb
# $main::AUTHLogUser = 0;                    # (0/1) write the username for AUTH (PLAIN/LOGIN) to maillog.txt
# $main::AUTHLogPWD = 0;                     # (0/1) write the userpassword for AUTH (PLAIN/LOGIN) to maillog.txt
# $main::forceDNSv4 = 1;                     # (0/1) force DNS querys to use IPv4 instead to try IPv6 first
# $main::forceTrunc4ClearDB = 0;             # (0/1) try/force a 'TRUNCATE TABLE' instead of a 'DELETE FROM' - 'DELETE FROM' is used as fall back if the truncate failes
# $main::BayesDomainPrior = 2;               # Bayesian/HMM domain entry priority (1 = lowest)
# $main::BayesPrivatPrior = 3;               # Bayesian/HMM privat/user entry priority (1 = lowest)
# $main::lockDatabases = 0;                  # (0/1) - locks all databases on access in every worker to prevent access violation
# $main::Unidecode2Console = 0;              # (0/1) use Text::Unidecode to decode NONASCII characters to ASCII - if available  - if set - 'ConsoleCharset' is ignored
# $main::DoSQL_LIKE = 1;                     # (0/1) do an 'DELETE FROM table WHERE pkey LIKE ?' to remove generic keys
# $main::SPF_max_dns_interactive_terms = 10; # max_dns_interactive_terms max number of SPF-mechanism per domain (defaults to 10)
# $main::neverQueueSize = 12000000;          # never queue mails larger than these number of bytes
# $main::SpamCountNormCorrection = 0;        # correct the required files in assp/spam by the number in percent
# $main::lockBDB = 1;                        # (0/1) use the CDB locking for BerkeleyDB (default = 1)
# $main::showMEM = 0;                        # show the current memory usage in every worker
# $main::FileScanCMDbuild_API = \&setFSCMD;  # called if defined in FileScanOK with - $FileScanCMDbuild_API->(\$cmd,$fh) - $cmd in place modification
# *********************************************************************************************************************************************

sub set {
#    $main::localnoDelayAddresses = 1;
#    &main::mlog(0,"info: localnoDelayAddresses set to 1");

#    $main::enableCrashAnalyzer = 1;
#    &main::mlog(0,"info: enableCrashAnalyzer set to 1");

#    $main::AllowInternalsInRegex = 1;
#    &main::mlog(0,"info: internal variables are now allowed in regular expressions");
}

# use this sub to change the FilsScanCMD to your needs - modify ${$cmd} in place
#sub setFSCMD {
#    my ($cmd, $this) = @_;
#    my @rcpt = split(/ /o,$this->{rcpt});
#    my $sender = $this->{mailfrom};
#    my $ip = $this->{ip};
#    my $cip = $this->{cip};
#    
#    ${$cmd} = '';
#}

1;

